<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 5.4 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="./">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">@@ESCET-VERSION-ENDUSER@@</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/@@ESCET-DEPLOY-FOLDER-NAME@@">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 5.4: Urgency</h1>
                    <p>
                        We now have timed models, which make use of variable <code>time</code> or continuous variables.
                        And we have hybrid models that combine these timing aspects with discrete events.
                        Hybrid models thus combine discrete event behavior and timed behavior.
                        The behavior of a system then consists of both discrete transitions for events (event transitions) and the passage of time (time transitions).
                        But, this begs the question: which of these takes priority?
                    </p>
                    <p>
                        That is determined by urgency.
                        CIF has event urgency and location urgency.
                        There is also edge urgency, but we recommend not using it, so it is not discussed in this course.
                        Event urgency was briefly mentioned earlier in the module, and we'll revisit it here in more detail.
                        After that, we'll look at location urgency.
                    </p>

                    <h2>Event urgency</h2>
                    <p>
                        Earlier in this module, the concept of <em>urgency</em>, and in particular event urgency, was already mentioned.
                        In CIF, transitions for events take priority over passage of time.
                        Thus, if any event is enabled and a transition can be taken for it, time will not pass and the event transition will be taken instead.
                        If then another event is enabled, a transition is taken for it as well, and so on.
                        Only once no event is enabled anymore, and thus no event transitions can be taken, will time start to pass.
                        And while time is passing, as soon as another event becomes enabled, time passage will stop and the event transition will be taken.
                        This is why a guard <code>time >= 10</code> still ensures that a transition can take place at the moment that <code>time</code> has reached value <code>10</code> (or very soon thereafter).
                    </p>

                    <h2>Location urgency</h2>
                    <p>
                        Besides event urgency, there is also location urgency.
                        Think back to the <a href="variable-time.html#stopwatch-example">stopwatch example</a> from earlier in the module.
                        Its state space was as follows:
                    </p>
                    <img src="images/stopwatch-statespace.png">
                    <p>
                        Once the automaton reaches location <code>Three</code>, time can progress infinitely.
                        To prevent time from progressing, the location can be made urgent.
                        Just like events being urgent prevents passage of time if they are enabled, being in an urgent location also prevents passage of time.
                        That is, if any automaton is an urgent location, time may not pass.
                        Note that you need only one automaton to be in an urgent location to prevent passage of time.
                        That is different from marked locations, where all automata must be in a marked location, in order to reach a marked state for the (entire) system.
                    </p>
                    <p id="stopwatch-model">
                        The CIF model of the stopwatch can be adapted as follows, to make the location urgent:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton Stopwatch:
                                event time_passed;

                                location Zero:
                                    initial;
                                    edge time_passed when time &gt;= 60  goto One;

                                location One:
                                    edge time_passed when time &gt;= 120 goto Two;

                                location Two:
                                    edge time_passed when time &gt;= 180 goto Three;

                                location Three:
                                    urgent;
                            end
                        </code>
                    </pre>
                    <p>
                        Location <code>Three</code> is specified as being urgent, similar to how locations can be marked.
                        Time may not progress while that location is the current location of the automaton.
                        This changes the state space of the model, which is then:
                    </p>
                    <img src="images/stopwatch-statespace-urgent.png">

                    <h2>Deadlock and livelock</h2>
                    <p>
                        In a discrete event model, a state is a <em>deadlock</em> state if no events are enabled and thus no event transitions are possible.
                        In a hybrid model, a state is a deadlock if no event transitions are possible, but also no time transitions are possible (time may not pass).
                        We're then stuck in the state and can't leave it.
                    </p>
                    <p>
                        You may also recall that in a discrete event model, a state is a <em>livelock</em> state if progress is possible by taking event transitions, but never a marked state can be reached.
                        In other words, it is a blocking state that is not a deadlock state.
                        Progress can be made, but it does not lead to the desired result of reaching a marked state.
                        In a hybrid model, we may additionally have a timed livelock if event transitions are always possible and thus time may never progress.
                        Progress can then still be made by event transitions, but this does not lead to ever allowing the passage of time again.
                    </p>
                    <p id="water-level">
                        Consider for instance the following CIF model, which has a timed livelock:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton WaterLevel:
                                event rise, drop;
                                cont level der velocity;
                                disc real velocity = 0;

                                location:
                                    initial;
                                    marked;
                                    edge rise when level <= 0 do velocity := velocity + 0.2;
                                    edge drop when level >= 3 do velocity := velocity - 0.2;
                            end
                        </code>
                    </pre>
                    <p>
                        This models the water level, for instance the water in the chamber of a water lock.
                        The water level may rise and drop, depending on the current water level.
                        That is, if the water level drops to zero, it rises (again).
                        And if it rises above 3 meters, it drops (again).
                    </p>
                    <p>
                        At least, that is the idea.
                        Initially, the water <code>level</code> is zero.
                        The edge for event <code>rise</code> is then enabled, and the <code>velocity</code> can be increased.
                        However, the edge remains enabled and the <code>velocity</code> can be increased again.
                        And again, and again, and again.
                        The event remains enabled, and <code>velocity</code> keeps increasing towards infinity.
                        But, as time may never pass, the <code>level</code> never actually raises above <code>0</code>.
                        And thus the <code>drop</code> event is never enabled.
                        The model thus has a timed livelock.
                    </p>
                    <p>
                        And there are more such situations where event urgency can lead to undesired effects.
                        Consider for instance a button that may be pressed and released by a user.
                        If we don't constrain the two events, and allow them to alternatingly occur one after the other, then time may never progress.
                        We don't know when the user presses or releases the button, so we can't specify the time after which the button press and release events become enabled.
                        And we don't even want to specify it, as we want the user to be able to press and release the button at any time.
                    </p>

                    <h2>Event urgency in practice</h2>
                    <p>
                        We thus want to allow certain events to happen at any time, but without specifying the time at which they may occur we have a timed livelock.
                        So, how do we solve this then?
                    </p>
                    <p>
                        In essence, since in the model we want to leave it open when the events occur, this must be decided somewhere else.
                        The model allows an event to happen at any time, but something else decides when it actually does occur.
                        We call this an <em>open model</em>.
                        Often, this moment when for instance a user presses the button, is decided by a person.
                        In CIF, we do not model this.
                        Instead, we consider it part of the environment of the model.
                        The exact times at which certain events occur is something that then becomes known only when the model is put together with its environment.
                        For instance, it may become known when we simulate a model and make explicit choices ourselves, or when we implement a controller in an actual system and connect it to a physical button that a user can press.
                    </p>
                    <p>
                        In a way, certain events may then have additional conditions that are imposed by the environment.
                        You could see this as the environment being another model, that has automata that also synchronize over these events, and impose additional conditions through their own guards.
                        When the open model is put together with its environment, the events get additional constraints, making it a <em>closed model</em>.
                        In practice however, the environment is typically not modeled, but something else acts as the environment.
                        As already mentioned, examples of practical environments are an actual physical system or a simulator.
                    </p>
                    <p>
                        One typical use case for this is when we simulate a model and connect some of the events to SVG input mappings.
                        Then the click on an element of the image leads to an event becoming enabled.
                        That way, the image is the environment, and a click determines the actual moment that the corresponding event occurs.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: "Which of the following statements is true?",
                                answers: [
                                    "If no events are enabled, time may always progress.",
                                    "If some events are enabled and others are not, time may progress.",
                                    "If any event is enabled, time may not progress.",
                                    "If all events are enabled, time may progress.",
                                    "If no events are enabled, time may not progress.",
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "Which of the following statements is true?",
                                answers: [
                                    "If all automata are in urgent locations, time may progress.",
                                    "If no automaton is in an urgent location, time may always progress.",
                                    "If none of the automata are in an urgent location, time may not progress.",
                                    "If any automaton is in an urgent location, time may not progress.",
                                    "If some automata are in urgent locations and others are not, time may progress.",
                                ],
                                correctAnswer: '4'
                            },
                            {
                                type: 'single-choice',
                                question: "Is it true that time may only progress if no events are enabled and none of the automata is in an urgent location?",
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements are true for the original version of the stopwatch mentioned above?",
                                answers: [
                                    "It has a deadlock.",
                                    "It has no deadlock.",
                                    "It has a timed livelock.",
                                    "It has no timed livelock.",
                                ],
                                correctAnswer: '2, 4'
                            },
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements are true for the adapted version of the stopwatch mentioned above?",
                                answers: [
                                    "It has a deadlock.",
                                    "It has no deadlock.",
                                    "It has a timed livelock.",
                                    "It has no timed livelock.",
                                ],
                                correctAnswer: '1, 4'
                            },
                            {
                                type: 'multiple-choice',
                                question: "Does the water level model shown above have a deadlock?",
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '2'
                            },
                        ];
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="continuous-variables.html">Go back to Module 5.3</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="tau-event.html">Proceed to Module 5.5</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
